uk.ac.starlink.table.formats

## Class AsciiTableBuilder

- java.lang.Object
- - uk.ac.starlink.table.formats.DocumentedTableBuilder
  - - uk.ac.starlink.table.formats.RowEvaluatorTableBuilder
    - - uk.ac.starlink.table.formats.AsciiTableBuilder

- All Implemented Interfaces:
    Documented, DocumentedIOHandler, TableBuilder

      public class AsciiTableBuilder
      extends RowEvaluatorTableBuilder

  A table builder which reads tables in simple ASCII format. The detailed format of input file which is understood is documented fully in the `AsciiStarTable` class.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsciiTableBuilder()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `docIncludesExample()` Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler.
    `java.lang.String` | `getFormatName()` Returns the name of the format which can be read by this handler.
    `java.lang.String` | `getXmlDescription()` Returns user-directed documentation in XML format.
    `StarTable` | `makeStarTable(DataSource datsrc, boolean wantRandom, StoragePolicy policy)` Constructs a `StarTable` based on a given `DataSource`.

    - ### Methods inherited from class uk.ac.starlink.table.formats.RowEvaluatorTableBuilder

      `canImport, canStream, getDecoders, getEncoding, getMaxSample, setDecoderExcludeList, setDecoders, setEncoding, setMaxSample, streamStarTable`

    - ### Methods inherited from class uk.ac.starlink.table.formats.DocumentedTableBuilder

      `getExtensions, looksLikeFile`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface uk.ac.starlink.table.formats.DocumentedIOHandler

      `matchesExtension, readText, toLink`

- - ### Constructor Detail

    - #### AsciiTableBuilder

          public AsciiTableBuilder()

  - ### Method Detail

    - #### getFormatName

          public java.lang.String getFormatName()

      Description copied from interface: `TableBuilder`
      Returns the name of the format which can be read by this handler. Matching against this string may be used by callers to identify or select this handler from a list.
      Returns:
        one-word description of this handler's format

    - #### makeStarTable

          public StarTable makeStarTable(DataSource datsrc,
                                         boolean wantRandom,
                                         StoragePolicy policy)
                                  throws TableFormatException,
                                         java.io.IOException

      Description copied from interface: `TableBuilder`
      Constructs a `StarTable` based on a given `DataSource`. If the source is not recognised or this builder does not know how to construct a table from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

      The `wantRandom` parameter is used to indicate whether, ideally, a random-access table should be returned. There is no requirement for the builder to honour this request, but if it knows how to make both random and non-random tables, it can use this flag to decide which to return.

      Note: the presence of the `wantRandom` parameter is somewhat misleading. TableBuilder implementations usually should, and do, ignore it (it would be removed from the interface if it were not for backward compatibility issues). Regardless of the value of this parameter, implementations should return a random-access table only if it is easy for them to do so; in particular they should not use the supplied `storagePolicy`, or any other resource-expensive measure, to randomise a sequential table just because the `wantRandom` parameter is true.

      Parameters:
        `datsrc` - the DataSource containing the table resource
        `wantRandom` - whether, preferentially, a random access table should be returned
        `policy` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        a StarTable made out of `datsrc`
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing

    - #### docIncludesExample

          public boolean docIncludesExample()

      Description copied from interface: `DocumentedIOHandler`
      Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler. Binary formats, or instances for which the `Documented.getXmlDescription()` method already includes some example output, should return false.
      Returns:
        true if the user documentation would benefit from the addition of an example serialization

    - #### getXmlDescription

          public java.lang.String getXmlDescription()

      Description copied from interface: `Documented`
      Returns user-directed documentation in XML format.

      The output should be a sequence of one or more <P> elements, using XHTML-like XML. Since rendering may be done in a number of contexts however, use of the full range of XHTML elements is discouraged. Where possible, the content should stick to simple markup such as the elements P, A, UL, OL, LI, DL, DT, DD EM, STRONG, I, B, CODE, TT, PRE.

      Returns:
        XML description of this object